'Alvin Elf
'by David Drake
'ddrake@foundrysearch.com
'December 2002

[loadGraphics]
    loadbmp "sleigh","sleigh.bmp"
    loadbmp "present1","present.bmp"
    loadbmp "present2","present2.bmp"
    loadbmp "present3","present3.bmp"
    loadbmp "elf","elf.bmp"
    loadbmp "smallpresent","smallpresent.bmp"

[openWindow]
    nomainwin
    WindowWidth = 800
    WindowHeight = 600
    UpperLeftX = DisplayWidth/2-800/2
    UpperLeftY = DisplayHeight/2 - 600/2
    graphicbox #main.gb, 0, 0, 800, 600
    open "Alvin Elf" for window as #main
    #main "trapclose [quit]"
    #main.gb "when characterInput [checkKeys]"
    #main.gb "color white;down;fill black;"

    for a = 1 to 500
        x =int(rnd(1)*800)
        y = int(rnd(1)*600)
        #main.gb "set ";x;" ";y
    next a
    #main.gb "getbmp bg 0 0 792 598";
    #main.gb "background bg";

    #main.gb "addsprite sleigh sleigh";
    #main.gb "addsprite elf elf"
    #main.gb "addsprite present1 present1";
    #main.gb "addsprite present2 present2";
    #main.gb "addsprite present3 present3";

    #main.gb "spritexy sleigh 350 1";
    #main.gb "spritexy elf 350 450";

        sleighX = 350
        sleighDX = 10
        elfX = 350

        present1X = 350
        present1Y = 10
        present1DX = 2
        #main.gb "spritexy present1 ";present1X;" ";present1Y;

        present2X = 360
        present2Y = 10
        present2DX = 2
        #main.gb "spritexy present2 ";present2X;" ";present2Y;

        present3X = 370
        present3Y = 10
        present3DX = 2
        #main.gb "spritexy present3 ";present3X;" ";present3Y;

        notice "Alvin Elf"+chr$(13)+_
                "Santa's landing gear is damaged and he needs your help!"+chr$(13)+_
                "Help Alvin Elf catch the presents Santa tosses down from"+chr$(13)+_
                "his sleigh.  Alvin will deliver these gifts to all the good"+chr$(13)+_
                "little girls and boys in the community.  However, if he drops"+chr$(13)+_
                "more than four, Santa will move on to the next community."+chr$(13)+_
                "(No need to waste gifts on fumble-fingered elves)."+chr$(13)+_
                "Santa's in a hurry and will toss the gifts faster as the"+chr$(13)+_
                "game progresses!  Good luck..."


        #main.gb "setfocus"

    timer 100, [animate]
    wait

[checkKeys]
    a$ = Inkey$
    if asc(right$(a$,1))=37 then [moveLeft]
    if asc(right$(a$,1))=39 then [moveRight]
    wait

[moveLeft]
    elfX = elfX - 20
    #main.gb "spritexy elf ";elfX;" 450"
    wait

[moveRight]
    elfX = elfX + 20
    #main.gb "spritexy elf ";elfX;" 450"
    wait

[animate]
    if time$("milliseconds") > soundTime then playwave "sleigh.wav",async:soundTime = time$("milliseconds")+7000

    if present1Falling <> 1 then present1X = sleighX
    if present2Falling <> 1 then present2X = sleighX
    if present3Falling <> 1 then present3X = sleighX

    sleighX = sleighX + sleighDX
    if sleighX > 650 or sleighX < 50 then
        if sleighX > 650 then sleighX = 640 : sleighDX = 0 - sleighDX
        if sleighX < 50 then sleighX = 60 : sleighDX = 0 - sleighDX
    end if
    #main.gb "spritexy sleigh ";sleighX;" 1";

    if present1Falling = 0 and rnd(1)*100 > 98-(level*3) then
            present1Falling = 1
            gravity1 = rnd(1)+level
            present1DX = int(rnd(1)*2)+level/2
            if rnd(1) > .5 then present1DX = present1DX * -1
    end if

    if present2Falling = 0 and rnd(1)*100 > 98-(level*3) then
            present2Falling = 1
            gravity2 = rnd(1)+level
            present2DX = int(rnd(1)*2)+level/2
            if rnd(1) > .5 then present2DX = present2DX * -1
    end if

    if present3Falling = 0 and rnd(1)*100 > 98-(level*3) then
            present3Falling = 1
            gravity3 = rnd(1)+level
            present3DX = int(rnd(1)*2)+level/2
            if rnd(1) > .5 then present3DX = present3DX * -1
    end if

    bgx= bgx+1
    if bgx > 792 then bgx = 1
    #main.gb "backgroundxy ";bgx;" 0";

    if present1Falling = 1 then
        gravity1 = gravity1 + .3
        present1Y = int(present1Y + 3 + gravity1)
        present1X = present1X - present1DX
        if present1Y > 700 then
            present1Y = 10
            present1X = sleighX
            present1Falling = 0
            gravity1 = 0
            gosub [miss]
        end if
    end if

    if present2Falling = 1 then
        gravity2 = gravity2 + .3
        present2Y = int(present2Y + 3 + gravity2)
        present2X = present2X - present2DX
        if present2Y > 700 then
            present2Y = 10
            present2X = sleighX
            present2Falling = 0
            gravity2 = 0
            gosub [miss]
        end if
    end if

    if present3Falling = 1 then
        gravity3 = gravity3 + .3
        present3Y = int(present3Y + 3 + gravity3)
        present3X = present3X - present3DX
        if present3Y > 700 then
            present3Y = 10
            present3X = sleighX
            present3Falling = 0
            gravity3 = 0
            gosub [miss]
        end if
    end if

    if misses > 3 then [gameOver]

    #main.gb "spritexy present1 ";present1X;" ";present1Y;
    #main.gb "spritexy present2 ";present2X;" ";present2Y;
    #main.gb "spritexy present3 ";present3X;" ";present3Y;

    #main.gb "drawsprites"

    #main.gb "spritecollides present1 present1$";
    #main.gb "spritecollides present2 present2$";
    #main.gb "spritecollides present3 present3$";

    if present1$ <> "" and present$<>"sleigh" then [checkCollisions]
    if present2$ <> "" and present$<>"sleigh" then [checkCollisions]
    if present3$ <> "" and present$<>"sleigh" then [checkCollisions]

    scan
    wait

[miss]
    misses = misses + 1
    playwave "anvil.wav",async
    soundTime = time$("milliseconds")+1500
    #main.gb "addsprite miss";misses;" smallpresent"
    #main.gb "spritexy miss";misses;" ";misses*20;" 0"
    return


[checkCollisions]
    if instr(present1$,"elf",0) > 0 then
        score = score + 1
        levelCount = levelCount + 1
'        playwave "magic.wav",async
        present1Y = 10
        present1Falling = 0
        soundTime = time$("milliseconds")+500
    end if

    if instr(present2$,"elf",0) > 0 then
        score = score + 1
        levelCount = levelCount + 1
'        playwave "magic.wav",async
        present2Y = 10
        present2Falling = 0
        soundTime = time$("milliseconds")+500
    end if

    if instr(present3$,"elf",0) > 0 then
        score = score + 1
        levelCount = levelCount + 1
'        playwave "magic.wav",async
        present3Y = 10
        present3Falling = 0
        soundTime = time$("milliseconds")+500
    end if

    if levelCount > 6 then
        levelCount = 0
        level = level + 1
        sleighDX = sleighDX + 2
        playwave "laugh.wav",async
        soundTime = time$("milliseconds")+3000
    end if

    wait

[gameOver]
    timer 0
    playwave ""
    notice "Game Over!"+chr$(13)+_
           "You caught ";score;" gifts!"+chr$(13)+_
           "The children of the world thank you."


[quit]
    playwave ""
    close #main
    unloadbmp "bg"
    unloadbmp "sleigh"
    unloadbmp "present1"
    unloadbmp "present2"
    unloadbmp "present3"
    unloadbmp "elf"
    unloadbmp "smallpresent"
    end

